"use strict";

var React = require("react");
var d3 = require("d3");

function getCurrentTimeParts() {
    var currentTime = new Date();

    return {
        hours: currentTime.getHours() + currentTime.getMinutes() / 60,
        minutes: currentTime.getMinutes(),
        seconds: currentTime.getSeconds()
    };
}

var secondsScale = d3.scale.linear().domain([0, 59 + 999 / 1000]).range([-90, 270]);
var minutesScale = d3.scale.linear().domain([0, 59 + 59 / 60]).range([-90, 270]);
var hoursScale = d3.scale.linear().domain([0, 11 + 59 / 60]).range([-90, 270]);


var Clock = React.createClass({
    displayName: "Clock",


    getInitialState: function getInitialState() {
        return getCurrentTimeParts();
    },

    componentDidMount: function componentDidMount() {
        var _this = this;
        setInterval(function () {
            _this.setState(getCurrentTimeParts());
        }, 1000);
    },

    render: function render() {
        var hoursStyle = {
            transform: "rotate(" + hoursScale(this.state.hours % 12) + "deg)"
        };
        var minutesStyle = {
            transform: "rotate(" + minutesScale(this.state.minutes) + "deg)"
        };
        var secondsStyle = {
            transform: "rotate(" + secondsScale(this.state.seconds) + "deg)"
        };

        return React.createElement(
            "div",
            null,
            React.createElement("div", { className: "time__clock__outer-circle" }),
            React.createElement(
                "span",
                { className: "time__clock__brand" },
                "mozaïk"
            ),
            React.createElement("div", { className: "time__clock__hand time__clock__hand--seconds", style: secondsStyle }),
            React.createElement("div", { className: "time__clock__hand time__clock__hand--minutes", style: minutesStyle }),
            React.createElement("div", { className: "time__clock__hand time__clock__hand--hours", style: hoursStyle }),
            React.createElement("div", { className: "time__clock__inner-circle" })
        );
    }
});

module.exports = Clock;